﻿__global__ void VFI(double *Vnew, int *policy, double *Vold, const double *P, const double* util, const int Nz, const int Na, const double *par)
{

    int COL = blockIdx.x * blockDim.x + threadIdx.x;
    int ROW = blockIdx.y * blockDim.y + threadIdx.y;

    double beta = par[0];

    //initialization
    double EV;
    double val = 0;
    double val2 = 0;
    int N = Na * Nz;
    int i1;
    int pol;

    //declare shared variables
    __shared__ double V[990];
    __shared__ double distance[990];

    V[ROW + COL * Na] = Vold[ROW + COL * Na];
    //synchronize the local threads writing to the local memory cache
    __syncthreads();

    double crit = 10;
    while (crit > 0.0001) {


        if (ROW < Na && COL < Nz) {
            val = -10000000;
            pol = 1;
            int i = 0;
            while (i < Na) { //possible capital choices

                //expected value function of 
                EV = 0;
                for (int i2 = 0; i2 < Nz; i2++) {
                    EV += beta * P[COL * Nz + i2] * V[i + i2 * Na];
                }
                val2 = util[i * N + ROW + COL * Na] + EV;
                if (val2 > val) {
                    val = val2;
                    pol = i;
                    i = i + 1;
                }
                else {
                    //break;
                    i = Na;
                }
            }
        }
        Vnew[ROW + COL * Na] = val;
        policy[ROW + COL * Na] = pol;
        distance[ROW + COL * Na] = abs(Vnew[ROW + COL * Na] - V[ROW + COL * Na]);


        //synchronize the local threads writing to the local memory cache
        __syncthreads();

        //find maximum distance
        crit = distance[0];
        i1 = 1;
        while (i1 < N) {
            if (distance[i1] > crit) {
                crit = distance[i1];
            }
            i1++;
        }
        V[ROW + COL * Na] = Vnew[ROW + COL * Na];
        //synchronize the local threads writing to the local memory cache
        __syncthreads();

    }

}
