clear all
close all
clc

%% GPU toolkit
beta = 0.99;
r = 0.01;

na = 330; %asset grid points
agrid = linspace(0,15,na)';
Z = [1 5 10]'; %productivity grid
P = [0.9 0.1 0; 0.1 0.8 0.1; 0 0.1 0.9];
nz = 3;

tol = 0.0001;

V = zeros(na,nz);
achoice = zeros(na,nz);

util = (1+r)*repmat(agrid,[1 nz na])+repmat(Z',[na 1 na])-repmat(reshape(agrid,[1 1 na]),[na nz 1]); %choice in 3rd dimension
util = max(util,10^(-13));
util = log(util);

%copy things to GPU
P_d = gpuArray(P');
P_d = gpuArray(P_d(:)');
V_d = gpuArray(V(:)');
util_d = gpuArray(util(:)');
parameters = gpuArray(beta);
Vnew_d = gpuArray(zeros(1,numel(V)));
achoice_d = gpuArray(int32(zeros(1,numel(V))));



k = parallel.gpu.CUDAKernel('VFI.ptx','VFI.cu');
k.ThreadBlockSize =[nz na 1]; %number of threads


[val, pol] = feval(k,Vnew_d,achoice_d,V_d,P_d,util_d,int32(nz),int32(na),parameters);


result_GPU = gather(val);
result_GPU = reshape(result_GPU,[na,nz]);
result_GPU_pol = gather(pol);
result_GPU_pol = reshape(result_GPU_pol,[na,nz])+1;
